<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="80px">
      <el-form-item label="设备MAC" prop="deviceMac">
        <el-input
            v-model="queryParams.deviceMac"
            placeholder="请输入设备MAC"
            clearable
            @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
            type="primary"
            plain
            icon="Plus"
            @click="handleAdd"
            v-hasPermi="['shop:labelInfo:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="success"
            plain
            icon="Edit"
            :disabled="single"
            @click="handleUpdate"
            v-hasPermi="['shop:labelInfo:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="danger"
            plain
            icon="Delete"
            :disabled="multiple"
            @click="handleDelete"
            v-hasPermi="['shop:labelInfo:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="warning"
            plain
            icon="Download"
            @click="handleExport"
            v-hasPermi="['shop:labelInfo:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="labelInfoList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="标签ID" align="center" prop="labelId" />
      <el-table-column label="设备ID" align="center" prop="deviceId" />
      <el-table-column label="设备MAC" align="center" prop="deviceMac" />
      <el-table-column label="商品ID" align="center" prop="goodsId" />
      <el-table-column label="模板ID" align="center" prop="templateId" />
      <el-table-column label="更新状态" align="center" prop="refreshStatus">
        <template #default="scope">
          <dict-tag :options="label_refresh_status" :value="scope.row.refreshStatus"/>
        </template>
      </el-table-column>
      <el-table-column label="更新次数" align="center" prop="refreshTimes" />
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button
              type="text"
              icon="Edit"
              @click="handleUpdate(scope.row)"
              v-hasPermi="['shop:labelInfo:edit']"
          >修改</el-button>
          <el-button
              type="text"
              icon="Delete"
              @click="handleDelete(scope.row)"
              v-hasPermi="['shop:labelInfo:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
        v-show="total>0"
        :total="total"
        v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize"
        @pagination="getList"
    />

    <!-- 添加或修改标签信息对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="labelInfoRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="设备MAC" prop="deviceMac">
          <el-input v-model="form.deviceMac" placeholder="请输入设备MAC" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="LabelInfo">
import { listLabelInfo, getLabelInfo, delLabelInfo, addLabelInfo, updateLabelInfo } from "@/api/shop/labelInfo";

const { proxy } = getCurrentInstance();
const { label_refresh_status } = proxy.useDict('label_refresh_status');

const labelInfoList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    deviceMac: null,
  },
  rules: {
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询标签信息列表 */
function getList() {
  loading.value = true;
  listLabelInfo(queryParams.value).then(response => {
    labelInfoList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    labelId: null,
    deptId: null,
    deviceId: null,
    deviceMac: null,
    goodsId: null,
    templateId: null,
    refreshStatus: "0",
    refreshTimes: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    remark: null
  };
  proxy.resetForm("labelInfoRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.labelId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加标签信息";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _labelId = row.labelId || ids.value
  getLabelInfo(_labelId).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改标签信息";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["labelInfoRef"].validate(valid => {
    if (valid) {
      if (form.value.labelId != null) {
        updateLabelInfo(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addLabelInfo(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _labelIds = row.labelId || ids.value;
  proxy.$modal.confirm('是否确认删除标签信息编号为"' + _labelIds + '"的数据项？').then(function() {
    return delLabelInfo(_labelIds);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('shop/labelInfo/export', {
    ...queryParams.value
  }, `labelInfo_${new Date().getTime()}.xlsx`)
}

getList();
</script>
